<?php
include_once $PATH_TO_CODE."/modules/dungeon/action/abstractaction.class.php";

abstract class DungeonAbstractChangeZoneTypeAction extends DungeonAbstractAction {
    function __construct($parActionType, $parNewZoneType, $parCost=0, $parChangeZoneNearBlock=false) {
        parent::__construct($parActionType);
        $this->newZoneType = $parNewZoneType;
        $this->cost = $parCost;
        $this->changeZoneNearBlock = $parChangeZoneNearBlock;
    }

    public function action($parZoneActionArray) {
        $locManageAction = ManageAction::getInstance();
        $locPlayer = $locManageAction->getPlayer();
        if($this->getZoneAndBlock($parZoneActionArray, $locZone, $locBlock)) {
            if($this->isOkToChange($locBlock, $locZone)) {
                $this->setNewZoneType($locZone);
            }
        }
    }

    //problem of ennemy and build near block ...
    public function isOkToChange($locBlock, $locZone) {
        $locManageAction = ManageAction::getInstance();
        $locPlayer = $locManageAction->getPlayer();
        if($locBlock->playerId==$locPlayer->playerId
                || ($this->changeZoneNearBlock && $locBlock->playerId == 0 && $locZone->atLeastOneZoneIsOwn($locPlayer->playerId, 1, 1, 1))) {
            if($locBlock->testIsInLostOfControlForAllianceId($locPlayer->allianceId)) {
				$locManageAction->addPlayerInfo("You are losing this block, you can't change anything on it");
            } else if($locZone->isOtherAllianceObjectNear($locPlayer->allianceId, 4, 4, 1)) {
            	$locManageAction->addPlayerInfo("Enemies are present in a range of 4 zones upper or lower, you can't change anything on this zone");
            } else if($locZone->isOtherAllianceObjectNear($locPlayer->allianceId, 7, 7, 0)) {
            	$locManageAction->addPlayerInfo("Enemies are present in a range of 7 zones in the same ground level, you can't change anything on this zone");
            } else if($locZone->isOtherAllianceZoneNear($locPlayer->allianceId, 1, 1, 1)) {
                $locManageAction->addPlayerInfo("At least one enemy block is adjacent of this zone, you can't change anything on it");
            } else {
                return $this->verifyPlayerEnoughCash($this->cost);
            }
        } else {
            $locManageAction->addPlayerInfo("You are not authorized to build here");
        }
        return false;
    }

    public function setNewZoneType($parZone) {
        if($this->verifyPlayerEnoughCash($this->cost)) {
            $locManageAction = ManageAction::getInstance();
            $locPlayer = $locManageAction->getPlayer();
            $locPlayer->addCash(-$this->cost);
            $locPlayer->addShame($this->shameCost);
            $parZone->setZoneType($this->newZoneType);
            $locManageAction->addPlayerInfo("New zone type: ".DungeonZone::staticGetZoneTypeToString($this->newZoneType).", cost: $this->cost");
        }
    }
}
?>