<?php
include_once $PATH_TO_CODE."/script/message/playermessage.class.php";

include_once $PATH_TO_CODE."/modules/dungeon/dungeonserver.class.php";

function initializeAccount($parPlayerId, $parPlayerType) {
	global $gloObjectManager;
	$locPlayer = $gloObjectManager->getPlayer($parPlayerId);
	$locPlayer->setAllianceId($parPlayerId);
	$locPlayer->setPlayerType($parPlayerType);
	dungeonInitLanguageWithPlayer($locPlayer);

	$locServer = DungeonServer::getInstance();
	if(isset($_POST["startX"]) && $_POST["startX"]!="") {
		$locWillStartBlockId = Block::getBlockIdWithCenterCoord(
		getGetPost("startX", 0),
		getGetPost("startY", 0),
		getGetPost("startZ", 0)+Site::$ZONE_COORD_Z_GROUND_LEVEL);
		if(Block::exist($locWillStartBlockId)) {
			$locCenterZoneId = $locServer->getAnHappyHomeNearBlockId($parPlayerType, $locWillStartBlockId);
		} else {
			echo "$locWillStartBlockId".dgettext("dungeon", " is not a correct block to start because is out of the world")."<br>";
			exit(0);
		}
	} else {
		$locCenterZoneId = $locServer->getAnHappyHomeBlockId($parPlayerType);
	}

	//Verify that zone exist
	if(!Zone::staticCanExist($locCenterZoneId)) {
		echo dgettext("dungeon", "No account can be created for the moment, please retry in 10 minutes or contact administrator site.")."<br>";
		exit(0);
	}
	
	//Delete all already existing unit
	$locAlreadyExistingObject = Player::staticGetAllRealObject($parPlayerId, true);
	foreach($locAlreadyExistingObject as $locObject) {
		$locObject->deleteObject();
	}
	

	$locBlock = $gloObjectManager->getBlock($locCenterZoneId);
	list($locXCenter, $locYCenter, $locZ) = Block::getBlockCoord($locBlock->blockId);
	$locCenterZone = $gloObjectManager->getZone($locCenterZoneId);
	$locNearZoneCenterId=Zone::getZoneId($locXCenter+1, $locYCenter, $locZ);
	$locNearCenterZone = $gloObjectManager->getZone($locNearZoneCenterId);
	$locCorner1 = $gloObjectManager->getZone(Zone::getZoneId($locXCenter+Constante::$HALF_BLOCK_SIZE, $locYCenter+Constante::$HALF_BLOCK_SIZE, $locZ));
	$locCorner2 = $gloObjectManager->getZone(Zone::getZoneId($locXCenter+Constante::$HALF_BLOCK_SIZE, $locYCenter-Constante::$HALF_BLOCK_SIZE, $locZ));
	$locCorner3 = $gloObjectManager->getZone(Zone::getZoneId($locXCenter-Constante::$HALF_BLOCK_SIZE, $locYCenter+Constante::$HALF_BLOCK_SIZE, $locZ));
	$locCorner4 = $gloObjectManager->getZone(Zone::getZoneId($locXCenter-Constante::$HALF_BLOCK_SIZE, $locYCenter-Constante::$HALF_BLOCK_SIZE, $locZ));

	if(DungeonConstante::$PLAYER_TYPE_UNDEAD == $parPlayerType) {
		$locZoneBuildUnitList = array($locCorner1, $locCorner2, $locCorner3, $locCorner4);
	} else {
		$locZoneBuildUnitList = array($locNearCenterZone, $locCorner1, $locCorner2, $locCorner3, $locCorner4);
	}
	
	$locListZoneIdToModify = Zone::getStaticZoneIdsFromXY($locCenterZoneId, 1, 1);
	foreach($locListZoneIdToModify as $locZoneIdToModify) {
		$locZoneToModify = $gloObjectManager->getZone($locZoneIdToModify);
		if(!$locZoneToModify->isGold()) {
			$locZoneToModify->setZoneType(Constante::$ZONE_TYPE_PLAIN);
		}
	}
	
	foreach($locZoneBuildUnitList as $locZoneBuildUnit) {
		$locZoneBuildUnit->setZoneType(Constante::$ZONE_TYPE_PLAIN);
		switch($parPlayerType) {
			case DungeonConstante::$PLAYER_TYPE_UNDEAD:
				Skeleton::create($locZoneBuildUnit, $locPlayer->playerId, false);
				$locNearCenterZone->setZoneType(DungeonConstante::$ZONE_TYPE_NECROPOLIS);
				break;
			case DungeonConstante::$PLAYER_TYPE_DUNGEON_MASTER:
				Grunt::create($locZoneBuildUnit, $locPlayer->playerId, false);
				$locNearCenterZone->setZoneType(DungeonConstante::$ZONE_TYPE_TREASURE);
				break;
			case DungeonConstante::$PLAYER_TYPE_HUMAN_KNIGHT:
				Soldier::create($locZoneBuildUnit, $locPlayer->playerId, false);
				$locNearCenterZone->setZoneType(DungeonConstante::$ZONE_TYPE_CITY);
				break;
			default:
				echo dgettext("dungeon", "not correct player type");
				exit(0);
		}
	}
	//echo "You begin at zone: ".$locCenterZone->toString()."<br><br>";

	
	$locBlock->setPlayerId($locPlayer->playerId);
	$locCenterZone->setZoneType(DungeonConstante::$ZONE_TYPE_BARRACK);

	if(substr($locPlayer->getLanguage(), 0, 2) == "fr") {
		//TODO : use get text
		PlayerMessage::getInstance()->addPlayerMessage(0, $locPlayer->playerId, "
    Bonjour,<br/>
<p>Merci d'avoir créer un compte dans dungeon. Je vous donne les premières instructions pour avoir un bon
commencement : 
<ul>
<li>cliquer sur une unité (une bordure rouge apparaît)
<li>cliquer sur l'action de déplacement <img src='image/actiontab/move.png' width='32px' height='32px'/>
<li>cliquer sur la carte
<li>un chemin bleu apparaît
</ul>
</p>
<p>
Maintenant vous avez juste à déplacer vos unités vers un block qui 
contient de l'or <img src='image/zonegold.png' width='32px' height='32px'/>.
</p>
<p>
N'oubliez pas de <a href='http://dungeon.no-ip.info/modules/dungeon/rules/rules.php'>lire les règles</a> et d'utiliser le boutton d'aide ('Helper').
</p>
Si vous avez des questions utilisez le <a href=http://sourceforge.net/forum/?group_id=186381>forum</a>.
</p>
<p>
Maintenant, déplacez vos unités et trouvez vos premières mines d'or !
</p>
<p>
Pour fermer ce message, cliquer sur le boutton 'message' ou sur <img src='image/interface/closewindow.png' width='20px' height='20px'/> qui est en haut de ce panneau.
</p>
");
	} else {
		PlayerMessage::getInstance()->addPlayerMessage(0, $locPlayer->playerId, "
    Hi,<br/>
<p>
Thanks to have create an account in dungeon. I give to you first instruction to get a good begin :
<ul>
 <li>click on a unit (a red border appear)
 <li>click on move action <img src='image/actiontab/move.png' width='32px' height='32px'/>
 <li>click on the map
 <li>a blue path is now show
</ul>
</p>
<p>
Next you have just to move your unit to block which contains gold 
<img src='image/zonegold.png' width='32px' height='32px'/>.
</p>
<p>
    Do not forget to <a href='http://dungeon.no-ip.info/modules/dungeon/rules/rules.php'>see rules</a> and use the 'Helper' button.
</p>
If you have other question use the <a href=http://sourceforge.net/forum/?group_id=186381>forum</a>
</p>
<p>
Now, move your unit to your first block with gold mine !
</p>
<p>
To close this message, just click on 'message' button or on the <img src='image/interface/closewindow.png' width='20px' height='20px'/> which is in the top of this panel
</p>
");
	}


	$locStartCash = DungeonPlayer::selectAverageIncomeForGoldMine()*20;
	switch($parPlayerType) {
		case DungeonConstante::$PLAYER_TYPE_HUMAN_KNIGHT:
			$locRangeToConquerGoldMine = 2;
			$locPlayer->setCash(max(30000, $locStartCash));
			PlayerMessage::getInstance()->addPlayerMessage(0, $locPlayer->playerId, 
				dgettext("dungeon", "You are a human, mine is in the underground, not in surface, so go down !"));
			break;
		default:
			$locPlayer->setCash(max(26000, $locStartCash));
			$locRangeToConquerGoldMine = 1;
	}

	$locPlayer->setShame(0);

	//All unoccuped gold mine in a range of 1 is taken, range of 2 for humain
	$locGoldZoneIdsToConquer = $locCenterZone->getAllZoneIdOfZoneType(DungeonConstante::$ZONE_TYPE_GOLD,
	$locRangeToConquerGoldMine*Constante::$BLOCK_SIZE+Constante::$HALF_BLOCK_SIZE*2,
	$locRangeToConquerGoldMine*Constante::$BLOCK_SIZE+Constante::$HALF_BLOCK_SIZE*2,
	$locRangeToConquerGoldMine);
	foreach($locGoldZoneIdsToConquer as $locGoldZoneIdToConquer) {
		$locZoneToConquer = $gloObjectManager->getZone($locGoldZoneIdToConquer);
		$gloObjectManager->getBlock($locZoneToConquer->blockId)->setPlayerId($parPlayerId);
	}

	//Delete all monsters !
	$res = $locBlock->getAllianceObjectNear(1, 4, 4, 4);
	while($row = mysql_fetch_array($res)) {
		$locObject = $gloObjectManager->getRealObject($row[0]);
		$locObject->deleteObject();
	}
	return true;
}
function dungeonInitLanguageWithPlayer(DungeonPlayer $parPlayer) {
	dungeonInitLanguage($parPlayer->getLanguage());
}
function dungeonInitLanguage($parLanguage="en_EN") {
	initLanguage($parLanguage);
	global $PATH_TO_CODE;
	bindtextdomain("dungeon", $PATH_TO_CODE."/modules/dungeon/translation");
}
function dungeonEchoAvailableLanguage($parSelected="en") {
	$locAvailableLanguage=array("fr_FR@euro", "français", "en", "english");
	for($i=0; $i < count($locAvailableLanguage); $i+=2) {
		echo "<option value='".$locAvailableLanguage[$i]."'";
		if($parSelected == $locAvailableLanguage[$i]) {
			echo " SELECTED";
		}
		echo ">".$locAvailableLanguage[$i+1];
		echo "</option>";
	}
}
?>