<?php
include_once $PATH_TO_CODE."/script/realobject.class.php";

abstract class DungeonRealObject extends RealObject {
	public static $REAL_OBJECT_INFO_TYPE1_LEVEL=100000;

	public static $REAL_OBJECT_INFO_TYPE2_XP_POINT=100000;

	public function __construct($parObjectInfo) {
		parent::__construct($parObjectInfo);
	}
	public function getLevel() {
		return $this->getObjectInfo(DungeonRealObject::$REAL_OBJECT_INFO_TYPE1_LEVEL, DungeonRealObject::$REAL_OBJECT_INFO_TYPE2_CURRENT_POINT);
	}
	public function getXP() {
		return $this->getObjectInfo(DungeonRealObject::$REAL_OBJECT_INFO_TYPE1_LEVEL, DungeonRealObject::$REAL_OBJECT_INFO_TYPE2_XP_POINT);
	}
	public function addXP($parXP) {
		$locNewXp = $parXP+$this->getXP();
		$locLevel = $this->getLevel();
		//e.g : to pass level 3 from level 2, the cost is 3 XP
		while($locNewXp - max(2, $locLevel+1) >= 0) {
			$locLevel++;
			$locNewXp -= max(2, $locLevel);
			if(0 == $locLevel%2) {
				$this->setObjectInfos(
				RealObject::$REAL_OBJECT_INFO_TYPE1_ACTION_POINT,
				RealObject::$REAL_OBJECT_INFO_TYPE2_MAX_POINT,
				$this->getMaxActionPoint()*1.1);
			}
			$this->setObjectInfos(
			RealObject::$REAL_OBJECT_INFO_TYPE1_FIGHT_ACTION_POINT,
			RealObject::$REAL_OBJECT_INFO_TYPE2_MAX_POINT,
			$this->getMaxFightActionPoint()*1.15);
				
			$this->addObjectInfos(
			RealObject::$REAL_OBJECT_INFO_TYPE1_LIFE_POINT,
			RealObject::$REAL_OBJECT_INFO_TYPE2_MAX_POINT,
			max(1, $this->getMaxLife()/10));
			
			$this->setLife($this->getLife()*1.1);
			
			if(0 == $locLevel%3) {
				for($i=0; $i < $this->getWeaponsCount(); $i++) {
					$this->addObjectInfos(
					RealObject::$REAL_OBJECT_INFO_TYPE1_AIM_ACCURENCY,
					$i, 1);
				}
			}
		}
		$this->setObjectInfos(
		DungeonRealObject::$REAL_OBJECT_INFO_TYPE1_LEVEL,
		DungeonRealObject::$REAL_OBJECT_INFO_TYPE2_CURRENT_POINT,
		$locLevel);
		$this->setObjectInfos(
		DungeonRealObject::$REAL_OBJECT_INFO_TYPE1_LEVEL,
		DungeonRealObject::$REAL_OBJECT_INFO_TYPE2_XP_POINT,
		$locNewXp);
	}
	public function kill($parKiller, $parSendAMessageToOwner=true) {
		if($parKiller) {
			//TODO : use power of the unit ! not the upkeep 
			//e.g : a unit level 1 kills an unit level 3 then it earns min(3, 6)=3Xp
			$locXpToWin =
			ceil(2*
			(max(1, $this->getLevel())/max(1, $parKiller->getLevel()))
			);
			$locXpToWin = max(1, min($parKiller->getLevel()*3, $locXpToWin));
			$parKiller->addXP($locXpToWin);
		}
		parent::kill($parKiller, $parSendAMessageToOwner);
	}
	public static function insertWeapon($parObjectId, $locWeaponNumber, $parAimPercentStartFire,
	$parAimAccurency, $parShootingRange, $parWeaponType,
	$parWeaponDamage) {
		RealObject::insertWeapon($parObjectId, $locWeaponNumber, $parAimPercentStartFire,
		$parAimAccurency, $parShootingRange, $parWeaponType,
		$parWeaponDamage);
	}
	public static function createObject($parObjectType,
	$parPlayer, $parZone, $parObjectCategory, $parIsLobotomize=false, $parDisplayPriority=1,
	$parVisibleState=0, $parCanTakeControl=1) {
		return RealObject::createObject($parObjectType,
		$parPlayer, $parZone, $parObjectCategory, $parIsLobotomize, $parDisplayPriority, $parVisibleState, $parCanTakeControl);
	}

	public static function insertInfo($parObjectId, $parMaxPoint,
	$parLifePoint, $parShield,
	$parMaxActionPoint,
	$parMaxFightPoint,
	$parSearchActionPoint,
	$parMoveCost, $parDigCost, $parFightCost, $parUpkeepCost, $parLobotomizeCounter=0) {
		RealObject::insertInfo($parObjectId, $parMaxPoint,
		$parLifePoint, $parShield,
		$parMaxActionPoint,
		$parMaxFightPoint,
		$parMoveCost, $parDigCost, $parFightCost, $parLobotomizeCounter);
		executer("INSERT INTO objectInfo(objectId, type1, type2, value) VALUES
                        ($parObjectId,
                        ".RealObject::$REAL_OBJECT_INFO_TYPE1_ACTION_COST.",
                        ".RealObject::$REAL_OBJECT_INFO_TYPE2_ACTION_SEARCH_TRAP_COST.",
                        $parSearchActionPoint),
                        ($parObjectId,
                        ".DungeonRealObject::$REAL_OBJECT_INFO_TYPE1_LEVEL.",
                        ".DungeonRealObject::$REAL_OBJECT_INFO_TYPE2_XP_POINT.",
                        0),
                        ($parObjectId,
                        ".DungeonRealObject::$REAL_OBJECT_INFO_TYPE1_LEVEL.",
                        ".RealObject::$REAL_OBJECT_INFO_TYPE2_CURRENT_POINT.",
                        1),
                        ($parObjectId,
                        ".RealObject::$REAL_OBJECT_INFO_TYPE1_COST.",
                        ".RealObject::$REAL_OBJECT_INFO_TYPE2_CURRENT_UPKEEP_COST.",
                        $parUpkeepCost)
                        ");
	}

	protected function getExtraImageParameters() {
		$locArray = parent::getExtraImageParameters();
		array_push($locArray, "l".$this->getLevel());
		return $locArray;
	}
	public function toStringPublicInfo() {
		$locStr = parent::toStringPublicInfo();
		$locStr .= "\nlevel: ".$this->getLevel();
		return $locStr;
	}
	public function toStringMessage() {
		$locStr = parent::toStringMessage();
		$locStr .= " level: ".$this->getLevel();
		return $locStr;
	}

}
?>