<?php
include_once $PATH_TO_CODE."/modules/dungeon/unit/undead/undeadrealobject.class.php";
include_once $PATH_TO_CODE."/script/zone.class.php";
include_once $PATH_TO_CODE."/script/imagemanager.class.php";
include_once $PATH_TO_CODE."/script/weapon.class.php";

include_once $PATH_TO_CODE."/script/log.class.php";

class DeadWorm extends UndeadRealObject
{
	
	public static $MOVE_COST_FACTOR=0.1;
	
	public function getObjectInfoValueImage() {
		return DungeonConstante::$REAL_OBJECT_INFO_VALUE_DEADWORM_IMAGE;
	}

	public static function create($parZone, $parPlayerId, $parIsLobotomize=true)
	{
		$parZone->occupedWithMovable();
		global $gloObjectManager;
		$locPlayer = $gloObjectManager->getPlayer($parPlayerId);
		$locObjectId = DungeonRealObject::createObject(DungeonConstante::$REAL_OBJECT_TYPE_DEADWORM,
		$locPlayer, $parZone, DungeonConstante::$REAL_OBJECT_CATEGORY_MEDIUM_INFANTERY, $parIsLobotomize);

		DungeonRealObject::insertInfo($locObjectId, 10, 10, 2,
		Constante::$REF_MAX_ACTION_POINT,
		Constante::$REF_MAX_FIGHT_ACTION_POINT,
		Constante::$REF_MAX_ACTION_POINT/8,Constante::$REF_MAX_ACTION_POINT*DeadWorm::$MOVE_COST_FACTOR,
		Constante::$REF_MAX_ACTION_POINT*1/20,Constante::$REF_MAX_FIGHT_ACTION_POINT/2,
		DungeonConstante::$ACTION_BUY_DEADWORM_COST*DungeonConstante::$UPKEEP_PRICE_MUX,
		($parIsLobotomize?20:0));

		DungeonRealObject::insertWeapon($locObjectId, 0, 10, -2,
		Weapon::$WEAPON_RANGE_HAND_TO_HAND, Weapon::$WEAPON_TYPE_AXIS,
		DungeonConstante::$WEAPON_DEFAULT_DAMAGE);

		return $locObjectId;
	}

	public static function staticGetName() {
		return "dead worm";
	}
	public function getName() {
		return DeadWorm::staticGetName();
	}

}
?>